/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the GatewayCreateDataExternalIds type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GatewayCreateDataExternalIds{}

// GatewayCreateDataExternalIds struct for GatewayCreateDataExternalIds
type GatewayCreateDataExternalIds struct {
	Var360ExternalId *string `json:"360_external_id,omitempty"`
	Var360ClientId *string `json:"360_client_id,omitempty"`
	WaPhoneNumberId *string `json:"wa_phone_number_id,omitempty"`
	WaWabaId *string `json:"wa_waba_id,omitempty"`
}

// NewGatewayCreateDataExternalIds instantiates a new GatewayCreateDataExternalIds object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGatewayCreateDataExternalIds() *GatewayCreateDataExternalIds {
	this := GatewayCreateDataExternalIds{}
	return &this
}

// NewGatewayCreateDataExternalIdsWithDefaults instantiates a new GatewayCreateDataExternalIds object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGatewayCreateDataExternalIdsWithDefaults() *GatewayCreateDataExternalIds {
	this := GatewayCreateDataExternalIds{}
	return &this
}

// GetVar360ExternalId returns the Var360ExternalId field value if set, zero value otherwise.
func (o *GatewayCreateDataExternalIds) GetVar360ExternalId() string {
	if o == nil || IsNil(o.Var360ExternalId) {
		var ret string
		return ret
	}
	return *o.Var360ExternalId
}

// GetVar360ExternalIdOk returns a tuple with the Var360ExternalId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayCreateDataExternalIds) GetVar360ExternalIdOk() (*string, bool) {
	if o == nil || IsNil(o.Var360ExternalId) {
		return nil, false
	}
	return o.Var360ExternalId, true
}

// HasVar360ExternalId returns a boolean if a field has been set.
func (o *GatewayCreateDataExternalIds) HasVar360ExternalId() bool {
	if o != nil && !IsNil(o.Var360ExternalId) {
		return true
	}

	return false
}

// SetVar360ExternalId gets a reference to the given string and assigns it to the Var360ExternalId field.
func (o *GatewayCreateDataExternalIds) SetVar360ExternalId(v string) {
	o.Var360ExternalId = &v
}

// GetVar360ClientId returns the Var360ClientId field value if set, zero value otherwise.
func (o *GatewayCreateDataExternalIds) GetVar360ClientId() string {
	if o == nil || IsNil(o.Var360ClientId) {
		var ret string
		return ret
	}
	return *o.Var360ClientId
}

// GetVar360ClientIdOk returns a tuple with the Var360ClientId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayCreateDataExternalIds) GetVar360ClientIdOk() (*string, bool) {
	if o == nil || IsNil(o.Var360ClientId) {
		return nil, false
	}
	return o.Var360ClientId, true
}

// HasVar360ClientId returns a boolean if a field has been set.
func (o *GatewayCreateDataExternalIds) HasVar360ClientId() bool {
	if o != nil && !IsNil(o.Var360ClientId) {
		return true
	}

	return false
}

// SetVar360ClientId gets a reference to the given string and assigns it to the Var360ClientId field.
func (o *GatewayCreateDataExternalIds) SetVar360ClientId(v string) {
	o.Var360ClientId = &v
}

// GetWaPhoneNumberId returns the WaPhoneNumberId field value if set, zero value otherwise.
func (o *GatewayCreateDataExternalIds) GetWaPhoneNumberId() string {
	if o == nil || IsNil(o.WaPhoneNumberId) {
		var ret string
		return ret
	}
	return *o.WaPhoneNumberId
}

// GetWaPhoneNumberIdOk returns a tuple with the WaPhoneNumberId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayCreateDataExternalIds) GetWaPhoneNumberIdOk() (*string, bool) {
	if o == nil || IsNil(o.WaPhoneNumberId) {
		return nil, false
	}
	return o.WaPhoneNumberId, true
}

// HasWaPhoneNumberId returns a boolean if a field has been set.
func (o *GatewayCreateDataExternalIds) HasWaPhoneNumberId() bool {
	if o != nil && !IsNil(o.WaPhoneNumberId) {
		return true
	}

	return false
}

// SetWaPhoneNumberId gets a reference to the given string and assigns it to the WaPhoneNumberId field.
func (o *GatewayCreateDataExternalIds) SetWaPhoneNumberId(v string) {
	o.WaPhoneNumberId = &v
}

// GetWaWabaId returns the WaWabaId field value if set, zero value otherwise.
func (o *GatewayCreateDataExternalIds) GetWaWabaId() string {
	if o == nil || IsNil(o.WaWabaId) {
		var ret string
		return ret
	}
	return *o.WaWabaId
}

// GetWaWabaIdOk returns a tuple with the WaWabaId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GatewayCreateDataExternalIds) GetWaWabaIdOk() (*string, bool) {
	if o == nil || IsNil(o.WaWabaId) {
		return nil, false
	}
	return o.WaWabaId, true
}

// HasWaWabaId returns a boolean if a field has been set.
func (o *GatewayCreateDataExternalIds) HasWaWabaId() bool {
	if o != nil && !IsNil(o.WaWabaId) {
		return true
	}

	return false
}

// SetWaWabaId gets a reference to the given string and assigns it to the WaWabaId field.
func (o *GatewayCreateDataExternalIds) SetWaWabaId(v string) {
	o.WaWabaId = &v
}

func (o GatewayCreateDataExternalIds) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GatewayCreateDataExternalIds) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Var360ExternalId) {
		toSerialize["360_external_id"] = o.Var360ExternalId
	}
	if !IsNil(o.Var360ClientId) {
		toSerialize["360_client_id"] = o.Var360ClientId
	}
	if !IsNil(o.WaPhoneNumberId) {
		toSerialize["wa_phone_number_id"] = o.WaPhoneNumberId
	}
	if !IsNil(o.WaWabaId) {
		toSerialize["wa_waba_id"] = o.WaWabaId
	}
	return toSerialize, nil
}

type NullableGatewayCreateDataExternalIds struct {
	value *GatewayCreateDataExternalIds
	isSet bool
}

func (v NullableGatewayCreateDataExternalIds) Get() *GatewayCreateDataExternalIds {
	return v.value
}

func (v *NullableGatewayCreateDataExternalIds) Set(val *GatewayCreateDataExternalIds) {
	v.value = val
	v.isSet = true
}

func (v NullableGatewayCreateDataExternalIds) IsSet() bool {
	return v.isSet
}

func (v *NullableGatewayCreateDataExternalIds) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGatewayCreateDataExternalIds(val *GatewayCreateDataExternalIds) *NullableGatewayCreateDataExternalIds {
	return &NullableGatewayCreateDataExternalIds{value: val, isSet: true}
}

func (v NullableGatewayCreateDataExternalIds) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGatewayCreateDataExternalIds) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


